<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: Memory APIs</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Memory APIs<br/>
<small>
[<a class="el" href="group__group__tivx__api.html">1: TIOVX Interface Modules</a>]</small>
</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Data Structures</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__shared__mem__ptr__t.html">tivx_shared_mem_ptr_t</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Structure describing a shared memory pointer.  <a href="structtivx__shared__mem__ptr__t.html#_details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#ga6c91b589548245063060d06629795033">tivxMemBufferAlloc</a> (<a class="el" href="structtivx__shared__mem__ptr__t.html">tivx_shared_mem_ptr_t</a> *mem_ptr, uint32_t size, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> mem_type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Alloc buffer from shared memory.  <a href="#ga6c91b589548245063060d06629795033"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#gabe21a01434fffe5237e13436c669a3b3">tivxMemBufferFree</a> (<a class="el" href="structtivx__shared__mem__ptr__t.html">tivx_shared_mem_ptr_t</a> *mem_ptr, uint32_t size)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Free buffer from shared memory.  <a href="#gabe21a01434fffe5237e13436c669a3b3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#gad0a080f8f697f50ce522f05e1e646cfc">tivxMemBufferMap</a> (void *host_ptr, uint32_t size, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> mem_type, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> maptype)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Map a allocated buffer address.  <a href="#gad0a080f8f697f50ce522f05e1e646cfc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#ga7eb36b10bc001dc9946b032828bd3e4d">tivxMemBufferUnmap</a> (void *host_ptr, uint32_t size, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> mem_type, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> maptype)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">UnMap a buffer address.  <a href="#ga7eb36b10bc001dc9946b032828bd3e4d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#ga240956e2a8001810af0e5bc8e2163b78">tivxMemHost2SharedPtr</a> (void *host_ptr, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> mem_type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert Host pointer to shared pointer.  <a href="#ga240956e2a8001810af0e5bc8e2163b78"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#ga719f8b4abbf094d104dd43c21f3f08ad">tivxMemShared2HostPtr</a> (void *shared_ptr, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> mem_type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert Shared memory pointer to host pointer.  <a href="#ga719f8b4abbf094d104dd43c21f3f08ad"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#ga853fc075881b71e7a4592fc0bf098ecb">tivxMemShared2TargetPtr</a> (void *shared_ptr, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> mem_type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert shared pointer to target pointer.  <a href="#ga853fc075881b71e7a4592fc0bf098ecb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#ga87a9c979d1fe5fb5dca1f127bb843d8d">tivxMemTarget2SharedPtr</a> (void *target_ptr, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> mem_type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert target memory pointer to shared pointer.  <a href="#ga87a9c979d1fe5fb5dca1f127bb843d8d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#gaf73adaa236689353ff173b268d49bf4b">tivxMemAlloc</a> (<a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a> size, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> mem_type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Allocates memory of given size.  <a href="#gaf73adaa236689353ff173b268d49bf4b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#ga1c3428e8e935844bd375655b3b9f3f34">tivxMemFree</a> (void *ptr, <a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a> size, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> mem_type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Frees already allocated memory.  <a href="#ga1c3428e8e935844bd375655b3b9f3f34"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#gac455e3957a61a111ced55bff62564ed0">tivxMemStats</a> (<a class="el" href="structtivx__mem__stats.html">tivx_mem_stats</a> *stats, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> mem_type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get memory segement information.  <a href="#gac455e3957a61a111ced55bff62564ed0"></a><br/></td></tr>
<tr><td colspan="2"><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__mem.html#ga16613a56b37f0bda2cc3fef86f40518e">tivx_mem_type_e</a> { <a class="el" href="group__group__tivx__mem.html#gga16613a56b37f0bda2cc3fef86f40518ea9efbb1abf57ed3bd769d6c7d8ee3a48d">TIVX_MEM_EXTERNAL</a>, 
<a class="el" href="group__group__tivx__mem.html#gga16613a56b37f0bda2cc3fef86f40518ea1f35a4596d35d81bdb534a657cecc557">TIVX_MEM_INTERNAL_L3</a>, 
<a class="el" href="group__group__tivx__mem.html#gga16613a56b37f0bda2cc3fef86f40518ea3ef35e2f23a736dba62cca6f01daa1d1">TIVX_MEM_INTERNAL_L2</a>
 }</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><p>Enum that list all possible memory regions from which allocations are possible. </p>
 <a href="group__group__tivx__mem.html#ga16613a56b37f0bda2cc3fef86f40518e">More...</a><br/></td></tr>
</table>
<hr/><h2>Enumeration Type Documentation</h2>
<a class="anchor" id="ga16613a56b37f0bda2cc3fef86f40518e"></a><!-- doxytag: member="tivx_mem.h::tivx_mem_type_e" ref="ga16613a56b37f0bda2cc3fef86f40518e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="group__group__tivx__mem.html#ga16613a56b37f0bda2cc3fef86f40518e">tivx_mem_type_e</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Enum that list all possible memory regions from which allocations are possible. </p>
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="gga16613a56b37f0bda2cc3fef86f40518ea9efbb1abf57ed3bd769d6c7d8ee3a48d"></a><!-- doxytag: member="TIVX_MEM_EXTERNAL" ref="gga16613a56b37f0bda2cc3fef86f40518ea9efbb1abf57ed3bd769d6c7d8ee3a48d" args="" -->TIVX_MEM_EXTERNAL</em>&nbsp;</td><td>
<p>External memory. </p>
<p>Typically large in size and can be used by kernels. as well as applications. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga16613a56b37f0bda2cc3fef86f40518ea1f35a4596d35d81bdb534a657cecc557"></a><!-- doxytag: member="TIVX_MEM_INTERNAL_L3" ref="gga16613a56b37f0bda2cc3fef86f40518ea1f35a4596d35d81bdb534a657cecc557" args="" -->TIVX_MEM_INTERNAL_L3</em>&nbsp;</td><td>
<p>Internal memory at L3 level. </p>
<p>Typically visiable to all CPUs, limited in size. Typically used by kernels and in very rare cases by applications. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga16613a56b37f0bda2cc3fef86f40518ea3ef35e2f23a736dba62cca6f01daa1d1"></a><!-- doxytag: member="TIVX_MEM_INTERNAL_L2" ref="gga16613a56b37f0bda2cc3fef86f40518ea3ef35e2f23a736dba62cca6f01daa1d1" args="" -->TIVX_MEM_INTERNAL_L2</em>&nbsp;</td><td>
<p>Internal memory at L2 level. </p>
<p>Typically local to CPU, very limited in size. Typically used by kernels.</p>
<p>This is used as scratch memory by kernels, i.e memory contents are not preserved across kernel function calls</p>
<p><a class="el" href="group__group__tivx__mem.html#gaf73adaa236689353ff173b268d49bf4b" title="Allocates memory of given size.">tivxMemAlloc()</a> API will linearly allocate from this memory segement. After each allocatation an internal offset will be incremented.</p>
<p><a class="el" href="group__group__tivx__mem.html#ga1c3428e8e935844bd375655b3b9f3f34" title="Frees already allocated memory.">tivxMemFree()</a> resets this offset to zero. i.e <a class="el" href="group__group__tivx__mem.html#gaf73adaa236689353ff173b268d49bf4b" title="Allocates memory of given size.">tivxMemAlloc()</a> and <a class="el" href="group__group__tivx__mem.html#ga1c3428e8e935844bd375655b3b9f3f34" title="Frees already allocated memory.">tivxMemFree()</a> are not heap like memory alloc and free functions.</p>
<p>NOT to be used by applications. </p>
</td></tr>
</table>
</dd>
</dl>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga6c91b589548245063060d06629795033"></a><!-- doxytag: member="tivx_mem.h::tivxMemBufferAlloc" ref="ga6c91b589548245063060d06629795033" args="(tivx_shared_mem_ptr_t *mem_ptr, uint32_t size, vx_enum mem_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> tivxMemBufferAlloc </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtivx__shared__mem__ptr__t.html">tivx_shared_mem_ptr_t</a> *&nbsp;</td>
          <td class="paramname"> <em>mem_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>mem_type</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Alloc buffer from shared memory. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>mem_type</em>&nbsp;</td><td>Memory type to which this allocation belongs, see <a class="el" href="group__group__tivx__mem.html#ga16613a56b37f0bda2cc3fef86f40518e">tivx_mem_type_e</a> </td></tr>
    <tr><td valign="top"><tt>[out]</tt>&nbsp;</td><td valign="top"><em>mem_ptr</em>&nbsp;</td><td>Allocated memory pointer </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>size</em>&nbsp;</td><td>Size of memory to allocate in bytes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gabe21a01434fffe5237e13436c669a3b3"></a><!-- doxytag: member="tivx_mem.h::tivxMemBufferFree" ref="gabe21a01434fffe5237e13436c669a3b3" args="(tivx_shared_mem_ptr_t *mem_ptr, uint32_t size)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> tivxMemBufferFree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtivx__shared__mem__ptr__t.html">tivx_shared_mem_ptr_t</a> *&nbsp;</td>
          <td class="paramname"> <em>mem_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>size</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free buffer from shared memory. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[out]</tt>&nbsp;</td><td valign="top"><em>mem_ptr</em>&nbsp;</td><td>Allocated memory pointer </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>size</em>&nbsp;</td><td>Size of memory allocated in bytes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gad0a080f8f697f50ce522f05e1e646cfc"></a><!-- doxytag: member="tivx_mem.h::tivxMemBufferMap" ref="gad0a080f8f697f50ce522f05e1e646cfc" args="(void *host_ptr, uint32_t size, vx_enum mem_type, vx_enum maptype)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tivxMemBufferMap </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>host_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>mem_type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>maptype</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Map a allocated buffer address. </p>
<p>This is to ensure the memory pointed by the buffer is accesible to the caller and brought to a coherent state wrt caller.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>host_ptr</em>&nbsp;</td><td>Buffer memory to map </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>size</em>&nbsp;</td><td>Size of memory to map in units of bytes </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>mem_type</em>&nbsp;</td><td>Memory type to which this pointer belongs, see <a class="el" href="group__group__tivx__mem.html#ga16613a56b37f0bda2cc3fef86f40518e">tivx_mem_type_e</a> </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>maptype</em>&nbsp;</td><td>Mapping type as defined by <a class="el" href="vx__types_8h.html#adc2f56f2c0b0255308ce90746b454fe6">vx_accessor_e</a> </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga7eb36b10bc001dc9946b032828bd3e4d"></a><!-- doxytag: member="tivx_mem.h::tivxMemBufferUnmap" ref="ga7eb36b10bc001dc9946b032828bd3e4d" args="(void *host_ptr, uint32_t size, vx_enum mem_type, vx_enum maptype)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tivxMemBufferUnmap </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>host_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>mem_type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>maptype</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>UnMap a buffer address. </p>
<p>This is to ensure the memory pointed by the buffer pointer is made coherent with other possible readers of this buffer</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>host_ptr</em>&nbsp;</td><td>Buffer memory to unmap </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>size</em>&nbsp;</td><td>Size of memory to unmap in units of bytes </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>mem_type</em>&nbsp;</td><td>Memory type to which this pointer belongs, see <a class="el" href="group__group__tivx__mem.html#ga16613a56b37f0bda2cc3fef86f40518e">tivx_mem_type_e</a> </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>maptype</em>&nbsp;</td><td>Mapping type as defined by <a class="el" href="vx__types_8h.html#adc2f56f2c0b0255308ce90746b454fe6">vx_accessor_e</a> </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga240956e2a8001810af0e5bc8e2163b78"></a><!-- doxytag: member="tivx_mem.h::tivxMemHost2SharedPtr" ref="ga240956e2a8001810af0e5bc8e2163b78" args="(void *host_ptr, vx_enum mem_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* tivxMemHost2SharedPtr </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>host_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>mem_type</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert Host pointer to shared pointer. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>host_ptr</em>&nbsp;</td><td>Host memory pointer </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>mem_type</em>&nbsp;</td><td>Memory type to which this pointer belongs, see <a class="el" href="group__group__tivx__mem.html#ga16613a56b37f0bda2cc3fef86f40518e">tivx_mem_type_e</a></td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Converted shared memory pointer </dd></dl>

</div>
</div>
<a class="anchor" id="ga719f8b4abbf094d104dd43c21f3f08ad"></a><!-- doxytag: member="tivx_mem.h::tivxMemShared2HostPtr" ref="ga719f8b4abbf094d104dd43c21f3f08ad" args="(void *shared_ptr, vx_enum mem_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* tivxMemShared2HostPtr </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>shared_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>mem_type</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert Shared memory pointer to host pointer. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>shared_ptr</em>&nbsp;</td><td>Shared memory pointer </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>mem_type</em>&nbsp;</td><td>Memory type to which this pointer belongs, see <a class="el" href="group__group__tivx__mem.html#ga16613a56b37f0bda2cc3fef86f40518e">tivx_mem_type_e</a></td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Converted host memory pointer </dd></dl>

</div>
</div>
<a class="anchor" id="ga853fc075881b71e7a4592fc0bf098ecb"></a><!-- doxytag: member="tivx_mem.h::tivxMemShared2TargetPtr" ref="ga853fc075881b71e7a4592fc0bf098ecb" args="(void *shared_ptr, vx_enum mem_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* tivxMemShared2TargetPtr </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>shared_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>mem_type</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert shared pointer to target pointer. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>shared_ptr</em>&nbsp;</td><td>Host memory pointer </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>mem_type</em>&nbsp;</td><td>Memory type to which this pointer belongs, see <a class="el" href="group__group__tivx__mem.html#ga16613a56b37f0bda2cc3fef86f40518e">tivx_mem_type_e</a></td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Converted shared memory pointer </dd></dl>

</div>
</div>
<a class="anchor" id="ga87a9c979d1fe5fb5dca1f127bb843d8d"></a><!-- doxytag: member="tivx_mem.h::tivxMemTarget2SharedPtr" ref="ga87a9c979d1fe5fb5dca1f127bb843d8d" args="(void *target_ptr, vx_enum mem_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* tivxMemTarget2SharedPtr </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>target_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>mem_type</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert target memory pointer to shared pointer. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>target_ptr</em>&nbsp;</td><td>Target memory pointer </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>mem_type</em>&nbsp;</td><td>Memory type to which this pointer belongs, see <a class="el" href="group__group__tivx__mem.html#ga16613a56b37f0bda2cc3fef86f40518e">tivx_mem_type_e</a></td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Converted host memory pointer </dd></dl>

</div>
</div>
<a class="anchor" id="gaf73adaa236689353ff173b268d49bf4b"></a><!-- doxytag: member="tivx_mem.h::tivxMemAlloc" ref="gaf73adaa236689353ff173b268d49bf4b" args="(vx_uint32 size, vx_enum mem_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* tivxMemAlloc </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a>&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>mem_type</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocates memory of given size. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>size</em>&nbsp;</td><td>size of the memory to be allocated</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Pointer to the allocated memory </dd></dl>

</div>
</div>
<a class="anchor" id="ga1c3428e8e935844bd375655b3b9f3f34"></a><!-- doxytag: member="tivx_mem.h::tivxMemFree" ref="ga1c3428e8e935844bd375655b3b9f3f34" args="(void *ptr, vx_uint32 size, vx_enum mem_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tivxMemFree </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a>&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>mem_type</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Frees already allocated memory. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>ptr</em>&nbsp;</td><td>Pointer to the memory </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>size</em>&nbsp;</td><td>size of the memory to be freed </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gac455e3957a61a111ced55bff62564ed0"></a><!-- doxytag: member="tivx_mem.h::tivxMemStats" ref="gac455e3957a61a111ced55bff62564ed0" args="(tivx_mem_stats *stats, vx_enum mem_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tivxMemStats </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtivx__mem__stats.html">tivx_mem_stats</a> *&nbsp;</td>
          <td class="paramname"> <em>stats</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>mem_type</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get memory segement information. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[out]</tt>&nbsp;</td><td valign="top"><em>stats</em>&nbsp;</td><td>Memory segment information </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>mem_type</em>&nbsp;</td><td>Memory segment ID </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
